#include <iostream>

#include "Covariance.h"

/*const Individual* Individual::cloning() const {
    std::cout << "\n\n'cloning()' in 'Individual' is called...\n";
    return new Individual; // Bad programming because 'delete' must be later called in calling context
}*/
Individual::~Individual()
{
    std::cout << " -Individual- ";
}
/*const Man* Man::cloning() const {
    std::cout << "\n\n'cloning()' in 'Man' is called...\n";
    return new Man; // Bad programming because 'delete' must be later called in calling context
}*/
Man::~Man()
{
    std::cout << " -Man- ";
}
/*const Woman* Woman::cloning() const {
    std::cout << "\n\n'cloning()' in 'Woman' is called...\n";
    return new Woman; // Bad programming because 'delete' must be later called in calling context
}*/
/*Woman::~Woman()
{
    std::cout << " -Woman- ";
}*/
const Individual Individual::cloning() const
{
    std::cout << "\n\n'cloning()' in 'Individual' is called...\n\n";
    return Individual();
}

const Individual Man::cloning() const
{
    std::cout << "\n\n'cloning()' in 'Man' is called...\n\n";
    return Man();
}

int main()
{
    const Individual &&FranckBarbier = Man();
    const Individual &&clone = FranckBarbier.cloning(); // Polymorphism!
    const Individual &&clone_ = clone.cloning(); // Np polymorphism?
    return 0;
}
